﻿[System.Reflection.Assembly]::LoadWithPartialName("Microsoft.AnalysisServices.Tabular")

$server = New-Object Microsoft.AnalysisServices.Tabular.Server
$server.Connect("localhost\tab16")
$db = $server.Databases["Contoso3"]
$model = $db.Model
$tableSales = $model.Tables["Sales"]
$partition = $tableSales.Partitions[0]
$source = New-Object Microsoft.AnalysisServices.Tabular.DataRefresh.QueryPartitionSourceOverride
$source.DataSource = $partition.Source.DataSource
$source.Query = "SELECT * FROM [Analytics].[Sales] WHERE [Order Date] >= '20170211'"
$po = New-Object Microsoft.AnalysisServices.Tabular.DataRefresh.PartitionOverride
$po.OriginalObject = $partition
$po.Source = $source
$oc = New-Object Microsoft.AnalysisServices.Tabular.DataRefresh.OverrideCollection
$oc.Partitions.Add($po)
$listoc = New-Object "System.Collections.Generic.List[Microsoft.AnalysisServices.Tabular.DataRefresh.OverrideCollection]"
$listoc.Add($oc)
$partition.RequestRefresh("Add", $listoc )
$model.SaveChanges();
